#include "include/common.h"

#include <stdio.h>
#include <time.h>

#include "tests.h"

int main(int argc, char* argv[])
{
    test_entry_t* entry;
    test_status_t stat;
    int i, count, passed;
    struct timespec start, end;
    int tdiff;
    (void)argc;
    (void)argv;

    passed = 0;
    count = sizeof(tests) / sizeof(tests[0]);

    /* Run all tests */
    for(i = 0; i < count; ++i){
        entry = &tests[i];

        clock_gettime(CLOCK_REALTIME, &start);
        stat = entry->fun();
        clock_gettime(CLOCK_REALTIME, &end);
        tdiff = rtcp_timespec_diff_nsec(&start, &end);

        switch(stat.ret){
        case TEST_PASS: {
            fprintf(stderr, "pass \"%s\" in %d.%03d usec\n",
                entry->name, tdiff / 1000, tdiff % 1000);
            ++passed;
        } break;
        case TEST_FAIL: {
            fprintf(stderr, "FAIL \"%s\" in %d.%03d usec, msg: \"%s\"\n",
                entry->name, tdiff / 1000, tdiff % 1000, stat.msg);
        } break;
        }
    }

    fprintf(stderr, "passed/total - %d/%d\n", passed, count);

    return 0;
}