#ifndef TESTS_H
#define TESTS_H

#include "include/common.h"

/** To register a test:
    1. forward declare it using TEST_DECLARE
    2. add it to the list of tests using TEST_ENTRY
*/

TEST_DECLARE(proto_yield)
TEST_DECLARE(proto_yield_flush)
TEST_DECLARE(proto_exit)
TEST_DECLARE(proto_spawn)
TEST_DECLARE(proto_yield_noncoop)
TEST_DECLARE(proto_yield_coop)
TEST_DECLARE(proto_loop_coop)

TEST_DECLARE(sched_alloc)
TEST_DECLARE(sched_queue)
TEST_DECLARE(sched_until)
TEST_DECLARE(sched_until_reverse)
TEST_DECLARE(sched_until_interleave)
TEST_DECLARE(sched_flush)
TEST_DECLARE(sched_sequence)
TEST_DECLARE(sched_stats)

TEST_DECLARE(hmap_add)
TEST_DECLARE(hmap_get)
TEST_DECLARE(hmap_get_multi)
TEST_DECLARE(hmap_del)
TEST_DECLARE(hmap_del_multi)
TEST_DECLARE(hmap_shrink)

TEST_DECLARE(uvec_add)
TEST_DECLARE(uvec_add_callback)
TEST_DECLARE(uvec_del)
TEST_DECLARE(uvec_del_callback)
TEST_DECLARE(uvec_del_callback_last)
TEST_DECLARE(uvec_shrink)

TEST_DECLARE(heap_insert)
TEST_DECLARE(heap_insert_callback)
TEST_DECLARE(heap_property_insert)
TEST_DECLARE(heap_extract)
TEST_DECLARE(heap_extract_callback)
TEST_DECLARE(heap_property_extract)
TEST_DECLARE(heap_shrink)

static test_entry_t tests[] = {

	TEST_ENTRY(proto_yield),
	TEST_ENTRY(proto_yield_flush),
	TEST_ENTRY(proto_exit),
	TEST_ENTRY(proto_spawn),
	TEST_ENTRY(proto_yield_noncoop),
	TEST_ENTRY(proto_yield_coop),
	TEST_ENTRY(proto_loop_coop),

	TEST_ENTRY(sched_alloc),
	TEST_ENTRY(sched_queue),
	TEST_ENTRY(sched_until),
	TEST_ENTRY(sched_until_reverse),
	TEST_ENTRY(sched_until_interleave),
	TEST_ENTRY(sched_flush),
	TEST_ENTRY(sched_sequence),
	TEST_ENTRY(sched_stats),

    TEST_ENTRY(hmap_add),
    TEST_ENTRY(hmap_get),
    TEST_ENTRY(hmap_get_multi),
    TEST_ENTRY(hmap_del),
    TEST_ENTRY(hmap_del_multi),
    TEST_ENTRY(hmap_shrink),

    TEST_ENTRY(uvec_add),
    TEST_ENTRY(uvec_add_callback),
    TEST_ENTRY(uvec_del),
    TEST_ENTRY(uvec_del_callback),
    TEST_ENTRY(uvec_del_callback_last),
    TEST_ENTRY(uvec_shrink),

    TEST_ENTRY(heap_insert),
    TEST_ENTRY(heap_insert_callback),
    TEST_ENTRY(heap_property_insert),
    TEST_ENTRY(heap_extract),
    TEST_ENTRY(heap_extract_callback),
    TEST_ENTRY(heap_property_extract),
    TEST_ENTRY(heap_shrink),
};

#endif /* TESTS_H */
